// (C) Wolfgang Huber 2010-2011

// Script parameters - these are set up by R in the function 'writeReport' when copying the 
//   template for this script from arrayQualityMetrics/inst/scripts into the report.

var highlightInitial = [ false, true, false, false, false, true, false, false, false, false, false, false, false, false, true, true, false, false, false, false, false, false, false, false ];
var arrayMetadata    = [ [ "1", "GSM2800849_SG14124393_257236310089_S002_GE1_1105_Oct12_1_1.txt" ], [ "2", "GSM2800850_SG14124393_257236310089_S002_GE1_1105_Oct12_1_2.txt" ], [ "3", "GSM2800851_SG14124393_257236310089_S002_GE1_1105_Oct12_1_3.txt" ], [ "4", "GSM2800852_SG14124393_257236310089_S002_GE1_1105_Oct12_1_4.txt" ], [ "5", "GSM2800853_SG14124393_257236310089_S002_GE1_1105_Oct12_2_1.txt" ], [ "6", "GSM2800854_SG14124393_257236310089_S002_GE1_1105_Oct12_2_2.txt" ], [ "7", "GSM2800855_SG14124393_257236310089_S002_GE1_1105_Oct12_2_3.txt" ], [ "8", "GSM2800856_SG14124393_257236310089_S002_GE1_1105_Oct12_2_4.txt" ], [ "9", "GSM2800873_SG14124393_257236310095_S001_GE1_1105_Oct12_1_1.txt" ], [ "10", "GSM2800874_SG14124393_257236310095_S001_GE1_1105_Oct12_1_2.txt" ], [ "11", "GSM2800875_SG14124393_257236310095_S001_GE1_1105_Oct12_1_3.txt" ], [ "12", "GSM2800876_SG14124393_257236310095_S001_GE1_1105_Oct12_1_4.txt" ], [ "13", "GSM2800877_SG14124393_257236310095_S001_GE1_1105_Oct12_2_1.txt" ], [ "14", "GSM2800878_SG14124393_257236310095_S001_GE1_1105_Oct12_2_2.txt" ], [ "15", "GSM2800879_SG14124393_257236310095_S001_GE1_1105_Oct12_2_3.txt" ], [ "16", "GSM2800880_SG14124393_257236310095_S001_GE1_1105_Oct12_2_4.txt" ], [ "17", "GSM2800913_SG14124393_257236310133_S001_GE1_1105_Oct12_1_1.txt" ], [ "18", "GSM2800914_SG14124393_257236310133_S001_GE1_1105_Oct12_1_2.txt" ], [ "19", "GSM2800915_SG14124393_257236310133_S001_GE1_1105_Oct12_1_3.txt" ], [ "20", "GSM2800916_SG14124393_257236310133_S001_GE1_1105_Oct12_1_4.txt" ], [ "21", "GSM2800917_SG14124393_257236310133_S001_GE1_1105_Oct12_2_1.txt" ], [ "22", "GSM2800918_SG14124393_257236310133_S001_GE1_1105_Oct12_2_2.txt" ], [ "23", "GSM2800919_SG14124393_257236310133_S001_GE1_1105_Oct12_2_3.txt" ], [ "24", "GSM2800920_SG14124393_257236310133_S001_GE1_1105_Oct12_2_4.txt" ] ];
var svgObjectNames   = [ "pca", "dens" ];

var cssText = ["stroke-width:1; stroke-opacity:0.4",
               "stroke-width:3; stroke-opacity:1" ];

// Global variables - these are set up below by 'reportinit'
var tables;             // array of all the associated ('tooltips') tables on the page
var checkboxes;         // the checkboxes
var ssrules;


function reportinit() 
{
 
    var a, i, status;

    /*--------find checkboxes and set them to start values------*/
    checkboxes = document.getElementsByName("ReportObjectCheckBoxes");
    if(checkboxes.length != highlightInitial.length)
	throw new Error("checkboxes.length=" + checkboxes.length + "  !=  "
                        + " highlightInitial.length="+ highlightInitial.length);
    
    /*--------find associated tables and cache their locations------*/
    tables = new Array(svgObjectNames.length);
    for(i=0; i<tables.length; i++) 
    {
        tables[i] = safeGetElementById("Tab:"+svgObjectNames[i]);
    }

    /*------- style sheet rules ---------*/
    var ss = document.styleSheets[0];
    ssrules = ss.cssRules ? ss.cssRules : ss.rules; 

    /*------- checkboxes[a] is (expected to be) of class HTMLInputElement ---*/
    for(a=0; a<checkboxes.length; a++)
    {
	checkboxes[a].checked = highlightInitial[a];
        status = checkboxes[a].checked; 
        setReportObj(a+1, status, false);
    }

}


function safeGetElementById(id)
{
    res = document.getElementById(id);
    if(res == null)
        throw new Error("Id '"+ id + "' not found.");
    return(res)
}

/*------------------------------------------------------------
   Highlighting of Report Objects 
 ---------------------------------------------------------------*/
function setReportObj(reportObjId, status, doTable)
{
    var i, j, plotObjIds, selector;

    if(doTable) {
	for(i=0; i<svgObjectNames.length; i++) {
	    showTipTable(i, reportObjId);
	} 
    }

    /* This works in Chrome 10, ssrules will be null; we use getElementsByClassName and loop over them */
    if(ssrules == null) {
	elements = document.getElementsByClassName("aqm" + reportObjId); 
	for(i=0; i<elements.length; i++) {
	    elements[i].style.cssText = cssText[0+status];
	}
    } else {
    /* This works in Firefox 4 */
    for(i=0; i<ssrules.length; i++) {
        if (ssrules[i].selectorText == (".aqm" + reportObjId)) {
		ssrules[i].style.cssText = cssText[0+status];
		break;
	    }
	}
    }

}

/*------------------------------------------------------------
   Display of the Metadata Table
  ------------------------------------------------------------*/
function showTipTable(tableIndex, reportObjId)
{
    var rows = tables[tableIndex].rows;
    var a = reportObjId - 1;

    if(rows.length != arrayMetadata[a].length)
	throw new Error("rows.length=" + rows.length+"  !=  arrayMetadata[array].length=" + arrayMetadata[a].length);

    for(i=0; i<rows.length; i++) 
 	rows[i].cells[1].innerHTML = arrayMetadata[a][i];
}

function hideTipTable(tableIndex)
{
    var rows = tables[tableIndex].rows;

    for(i=0; i<rows.length; i++) 
 	rows[i].cells[1].innerHTML = "";
}


/*------------------------------------------------------------
  From module 'name' (e.g. 'density'), find numeric index in the 
  'svgObjectNames' array.
  ------------------------------------------------------------*/
function getIndexFromName(name) 
{
    var i;
    for(i=0; i<svgObjectNames.length; i++)
        if(svgObjectNames[i] == name)
	    return i;

    throw new Error("Did not find '" + name + "'.");
}


/*------------------------------------------------------------
  SVG plot object callbacks
  ------------------------------------------------------------*/
function plotObjRespond(what, reportObjId, name)
{

    var a, i, status;

    switch(what) {
    case "show":
	i = getIndexFromName(name);
	showTipTable(i, reportObjId);
	break;
    case "hide":
	i = getIndexFromName(name);
	hideTipTable(i);
	break;
    case "click":
        a = reportObjId - 1;
	status = !checkboxes[a].checked;
	checkboxes[a].checked = status;
	setReportObj(reportObjId, status, true);
	break;
    default:
	throw new Error("Invalid 'what': "+what)
    }
}

/*------------------------------------------------------------
  checkboxes 'onchange' event
------------------------------------------------------------*/
function checkboxEvent(reportObjId)
{
    var a = reportObjId - 1;
    var status = checkboxes[a].checked;
    setReportObj(reportObjId, status, true);
}


/*------------------------------------------------------------
  toggle visibility
------------------------------------------------------------*/
function toggle(id){
  var head = safeGetElementById(id + "-h");
  var body = safeGetElementById(id + "-b");
  var hdtxt = head.innerHTML;
  var dsp;
  switch(body.style.display){
    case 'none':
      dsp = 'block';
      hdtxt = '-' + hdtxt.substr(1);
      break;
    case 'block':
      dsp = 'none';
      hdtxt = '+' + hdtxt.substr(1);
      break;
  }  
  body.style.display = dsp;
  head.innerHTML = hdtxt;
}
